using GLib;
using Gtk;
using Gdk;
using Hildon;
using Osso;

public string apptitle;
public string exttext;
public string filename;

static void println (string str) {
    stdout.printf ("%s\n", str);
}

public class mainProgram : Hildon.Program {
        Hildon.Window window;
        Label label;
		
		construct {
                window = new Hildon.Window ();
				window.set_icon_from_file ("/usr/share/pixmaps/"+apptitle.down()+".png");
                window.destroy += Gtk.main_quit;
                add_window (window);

                Environment.set_application_name (apptitle);
                window.map_event += activate;
                
                window.show_all();
		}
		
		bool activate( Gtk.Widget widget, Gdk.Event event ) {
		        string Cons, ErrorCons, vwr;
		        int ExitStatus;
		        
		        Process.spawn_command_line_sync(filename, out Cons, out ErrorCons, out ExitStatus);
	            Gtk.main_quit();
	            return false;
		}

        static int main (string[] args) {
                Osso.Context ctx;

                Gtk.init (ref args);
                
                apptitle = args[1];
                filename = args[2];
                
                ctx = new Osso.Context(apptitle, "0.1", false, null);

                if (ctx.display_state_on() != Osso.Error.OK)
                    println("Error: Osso Initialize failed.\n");
                
                var prg = new mainProgram ();
                Gtk.main();
                
                return 0;
        }
}

